#!/usr/bin/env python

import os
import subprocess, shlex
from app import app, db
from flask_script import Manager, Shell, Command
from flask_migrate import Migrate, MigrateCommand

def make_shell_context():
    return dict(app=app,
                db=db, 
                User=User, 
                Role=Role, 
                Permission=Permission, 
                Deployment=Deployment)

migrate = Migrate(app, db)

manager = Manager(app)
manager.add_command('shell', Shell(make_context=make_shell_context))
manager.add_command('db', MigrateCommand)

@manager.command
def deploy():
    """Run deployment tasks."""
    from flask_migrate import upgrade
    from app.models import Role, User

    # migrate database to latest revision
    upgrade()

    # create user roles
    Role.insert_roles()

@manager.command
def charge():
    print('charge')
    from app.models import Deployment, Service, Domain
    #Deployment.charge()
    #Service.charge()
    #Domain.charge()

@manager.command
def runserver():
    print('Starting Flask...')
    app.run()

if __name__ == '__main__':
    manager.run()

